﻿using System.Security.Permissions;
using System.Web.Mvc;
using System.Web.Security;

namespace RBACExample.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Login(string returnUrl)
        {
            FormsAuthentication.SetAuthCookie("admin", false);
            return Redirect(returnUrl);
        }

        public ActionResult Logoff()
        {
            FormsAuthentication.SignOut();
            return Redirect("/");
        }

        public ActionResult Index()
        {
            return Content("home");
        }

        //[Authorize]
        public ActionResult Account()
        {
            return Content(string.Format("user is IsAuthenticated:{0}", User.Identity.IsAuthenticated));
        }

        //[Authorize(Roles="admin")]
        public ActionResult Admin()
        {
            new ServiceTest().Test();
            return Content(string.Format("user is in role admin:{0}", User.IsInRole("admin")));
        }
    }

    public class ServiceTest
    {
        [PrincipalPermission(SecurityAction.Demand, Role = "admin")]
        public void Test()
        {
        }
    }
}